

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Making your first request &mdash; FnacMarketplace API 2.1.0 documentation</title>
    
    <link rel="stylesheet" href="../_static/haiku.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../_static/print.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '2.1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/theme_extras.js"></script>
    <link rel="top" title="FnacMarketplace API 2.1.0 documentation" href="../index.html" />
    <link rel="up" title="Api documentation" href="index.html" />
    <link rel="next" title="Authentification" href="api/authentification.html" />
    <link rel="prev" title="How to use this documentation" href="howtouse.html" /> 
  </head>
  <body>
      <div class="header"><img class="rightlogo" src="../_static/fnac.gif" alt="Logo"/><h1 class="heading"><a href="../index.html">
          <span>FnacMarketplace API 2.1.0 documentation</span></a></h1>
        <h2 class="heading"><span>Making your first request</span></h2>
      </div>
      <div class="topnav">
      
        <p>
        «&#160;&#160;<a href="howtouse.html">How to use this documentation</a>
        &#160;&#160;::&#160;&#160;
        <a class="uplink" href="../index.html">Contents</a>
        &#160;&#160;::&#160;&#160;
        <a href="api/authentification.html">Authentification</a>&#160;&#160;»
        </p>

      </div>
      <div class="content">
        
        
  <div class="section" id="making-your-first-request">
<h1>Making your first request<a class="headerlink" href="#making-your-first-request" title="Permalink to this headline">¶</a></h1>
<dl class="docutils">
<dt>Using our API is consisting in 3 steps:</dt>
<dd><ul class="first last simple">
<li>Authenticating to our platform</li>
<li>Sending an XML request to the right service</li>
<li>Handling the given response</li>
</ul>
</dd>
</dl>
<p>Here is below a quick PHP implementation example to make an offers_update request to create an offer.</p>
<div class="highlight-php"><div class="highlight"><pre><span class="cp">&lt;?php</span>
  <span class="c1">// Fnac Marketplace offers_update example</span>

  <span class="c1">// Set the API authentication parameters</span>
  <span class="nv">$partner_id</span> <span class="o">=</span> <span class="s1">&#39;509491E8-7341-AE98-F708-11768C65539C&#39;</span><span class="p">;</span>
  <span class="nv">$shop_id</span>    <span class="o">=</span> <span class="s1">&#39;0EA474AC-BE18-5F77-D7F0-E509DE2AABC7&#39;</span><span class="p">;</span>
  <span class="nv">$key</span>        <span class="o">=</span> <span class="s1">&#39;0D00AF3D-D33F-B5F1-3A5F-BF153C8DAE06&#39;</span><span class="p">;</span>

  <span class="nv">$url</span>        <span class="o">=</span> <span class="s1">&#39;https://partners-test.mp.fnacdarty.com/api.php/&#39;</span><span class="p">;</span>

  <span class="c1">// STEP 1: Authenticate to the API</span>
  <span class="c1">// Generate the authentication request</span>
  <span class="nv">$auth_request_xml</span> <span class="o">=</span> <span class="s">&lt;&lt;&lt;XML</span>
<span class="s">&lt;?xml version=&#39;1.0&#39; encoding=&#39;utf-8&#39;?&gt;</span>
<span class="s">&lt;auth xmlns=&#39;http://www.fnac.com/schemas/mp-dialog.xsd&#39;&gt;</span>
<span class="s">  &lt;partner_id&gt;00000000-0000-0000-0000-000000000000&lt;/partner_id&gt;</span>
<span class="s">  &lt;shop_id&gt;00000000-0000-0000-0000-000000000000&lt;/shop_id&gt;</span>
<span class="s">  &lt;key&gt;00000000-0000-0000-0000-000000000000&lt;/key&gt;</span>
<span class="s">&lt;/auth&gt;</span>
<span class="s">XML;</span>


  <span class="nv">$xmlAuthentication</span>              <span class="o">=</span> <span class="nb">simplexml_load_string</span><span class="p">(</span><span class="nv">$auth_request_xml</span><span class="p">);</span>
  <span class="c1">// Load authentication parameters within request</span>
  <span class="nv">$xmlAuthentication</span><span class="o">-&gt;</span><span class="na">partner_id</span>  <span class="o">=</span> <span class="nv">$partner_id</span><span class="p">;</span>
  <span class="nv">$xmlAuthentication</span><span class="o">-&gt;</span><span class="na">shop_id</span>     <span class="o">=</span> <span class="nv">$shop_id</span><span class="p">;</span>
  <span class="nv">$xmlAuthentication</span><span class="o">-&gt;</span><span class="na">key</span>         <span class="o">=</span> <span class="nv">$key</span><span class="p">;</span>

  <span class="c1">// Send xml request to webservice auth</span>
  <span class="nv">$response</span>    <span class="o">=</span> <span class="nx">do_post_request</span><span class="p">(</span><span class="nv">$url</span> <span class="o">.</span> <span class="s2">&quot;auth&quot;</span><span class="p">,</span> <span class="nv">$xmlAuthentication</span><span class="o">-&gt;</span><span class="na">asXML</span><span class="p">());</span>
  <span class="nv">$xmlResponse</span> <span class="o">=</span> <span class="nb">simplexml_load_string</span><span class="p">(</span><span class="nb">trim</span><span class="p">(</span><span class="nv">$response</span><span class="p">));</span>

  <span class="c1">// Display auth response</span>
  <span class="nb">var_dump</span><span class="p">(</span><span class="nv">$xmlResponse</span><span class="p">);</span>
  <span class="k">echo</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&lt;hr/&gt;&quot;</span><span class="p">;</span>

  <span class="c1">// Get token for session authentication</span>
  <span class="nv">$token</span> <span class="o">=</span> <span class="nv">$xmlResponse</span><span class="o">-&gt;</span><span class="na">token</span><span class="p">;</span>

  <span class="c1">// STEP 2: Send an offers_update request</span>
  <span class="c1">// Generate the offers_update request</span>
  <span class="nv">$offers_update_request_xml</span> <span class="o">=</span> <span class="s">&lt;&lt;&lt;XML</span>
<span class="s">&lt;?xml version=&#39;1.0&#39; encoding=&quot;utf-8&quot;?&gt;</span>
<span class="s">&lt;offers_update partner_id=&quot;00000000-0000-0000-0000-000000000000&quot; shop_id=&quot;00000000-0000-0000-0000-000000000000&quot; token=&quot;00000000-0000-0000-0000-000000000000&quot; xmlns=&#39;http://www.fnac.com/schemas/mp-dialog.xsd&#39;&gt;</span>
<span class="s">  &lt;offer&gt;</span>
<span class="s">    &lt;product_reference type=&#39;Ean&#39;&gt;0886971942323&lt;/product_reference&gt;</span>
<span class="s">    &lt;offer_reference type=&#39;SellerSku&#39;&gt;SKU_TEST_1&lt;/offer_reference&gt;</span>
<span class="s">    &lt;price&gt;50&lt;/price&gt;</span>
<span class="s">    &lt;product_state&gt;11&lt;/product_state&gt;</span>
<span class="s">    &lt;quantity&gt;999&lt;/quantity&gt;</span>
<span class="s">    &lt;description&gt;Ceci est une offre de test.&lt;/description&gt;</span>
<span class="s">  &lt;/offer&gt;</span>
<span class="s">&lt;/offers_update&gt;</span>
<span class="s">XML;</span>


  <span class="nv">$xmlOffersUpdate</span>               <span class="o">=</span> <span class="nb">simplexml_load_string</span><span class="p">(</span><span class="nv">$offers_update_request_xml</span><span class="p">);</span>
  <span class="c1">// Load authentication parameters and token within request</span>
  <span class="nv">$xmlOffersUpdate</span><span class="p">[</span><span class="s1">&#39;partner_id&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="nv">$partner_id</span><span class="p">;</span>
  <span class="nv">$xmlOffersUpdate</span><span class="p">[</span><span class="s1">&#39;shop_id&#39;</span><span class="p">]</span>    <span class="o">=</span> <span class="nv">$shop_id</span><span class="p">;</span>
  <span class="nv">$xmlOffersUpdate</span><span class="p">[</span><span class="s1">&#39;token&#39;</span><span class="p">]</span>      <span class="o">=</span> <span class="nv">$token</span><span class="p">;</span>

  <span class="nx">libxml_use_internal_errors</span><span class="p">(</span><span class="k">true</span><span class="p">);</span>
  <span class="nv">$dom</span> <span class="o">=</span> <span class="k">new</span> <span class="nx">DOMDocument</span><span class="p">;</span>
  <span class="nv">$dom</span><span class="o">-&gt;</span><span class="na">loadXML</span><span class="p">(</span><span class="nv">$xmlOffersUpdate</span><span class="o">-&gt;</span><span class="na">asXML</span><span class="p">());</span>

  <span class="c1">// Check XSD compliance of the generated request. This step is very useful to spot possible formatting errors.</span>
  <span class="nv">$valid</span> <span class="o">=</span> <span class="nv">$dom</span><span class="o">-&gt;</span><span class="na">schemaValidate</span><span class="p">(</span><span class="s1">&#39;../xsd/OffersUpdateService.xsd&#39;</span><span class="p">);</span>
  <span class="nv">$error</span> <span class="o">=</span> <span class="nx">libxml_get_errors</span><span class="p">();</span>
  <span class="k">if</span><span class="p">(</span><span class="o">!</span><span class="nv">$valid</span><span class="p">)</span>
  <span class="p">{</span>
    <span class="c1">// Display found errors</span>
    <span class="nb">var_dump</span><span class="p">(</span><span class="nv">$error</span><span class="p">);</span>
    <span class="k">die</span><span class="p">();</span>
  <span class="p">}</span>

  <span class="c1">// Send xml to webservice OffersUpdate</span>
  <span class="nv">$response</span>    <span class="o">=</span> <span class="nx">do_post_request</span><span class="p">(</span><span class="nv">$url</span> <span class="o">.</span> <span class="s2">&quot;offers_update&quot;</span><span class="p">,</span> <span class="nv">$xmlOffersUpdate</span><span class="o">-&gt;</span><span class="na">asXML</span><span class="p">());</span>
  <span class="nv">$xmlResponse</span> <span class="o">=</span> <span class="nb">simplexml_load_string</span><span class="p">(</span><span class="nb">trim</span><span class="p">(</span><span class="nv">$response</span><span class="p">));</span>

  <span class="c1">// STEP 3: Handle the response</span>
  <span class="c1">// Offers_update gives the batch id which can be used with batch_status service to get status of your import. Here, we are simply displaying it.</span>
  <span class="nb">var_dump</span><span class="p">(</span><span class="nv">$xmlResponse</span><span class="p">);</span>



 <span class="sd">/***</span>
<span class="sd">  * do_post_request</span>
<span class="sd">  * ===============</span>
<span class="sd">  * @param string $url contains the service url to call for the request.</span>
<span class="sd">  * @param string $data contains the request to send. In this purpose, XML data are sent.</span>
<span class="sd">  *</span>
<span class="sd">  * This function sends request by POST. Any method to send the request can be used, here we are using a cURL session.</span>
<span class="sd">  */</span>

  <span class="k">function</span> <span class="nf">do_post_request</span><span class="p">(</span><span class="nv">$url</span><span class="p">,</span> <span class="nv">$data</span><span class="p">)</span>
  <span class="p">{</span>
    <span class="nv">$ch</span> <span class="o">=</span> <span class="nb">curl_init</span><span class="p">();</span>

    <span class="c1">// Depending on your system, you may add other options or modify the following ones.</span>
    <span class="nb">curl_setopt</span><span class="p">(</span><span class="nv">$ch</span><span class="p">,</span> <span class="nx">CURLOPT_FOLLOWLOCATION</span><span class="p">,</span> <span class="mi">1</span><span class="p">);</span>
    <span class="nb">curl_setopt</span><span class="p">(</span><span class="nv">$ch</span><span class="p">,</span> <span class="nx">CURLOPT_POST</span><span class="p">,</span> <span class="mi">1</span><span class="p">);</span>
    <span class="nb">curl_setopt</span><span class="p">(</span><span class="nv">$ch</span><span class="p">,</span> <span class="nx">CURLOPT_URL</span><span class="p">,</span> <span class="nv">$url</span><span class="p">);</span>
    <span class="nb">curl_setopt</span><span class="p">(</span><span class="nv">$ch</span><span class="p">,</span> <span class="nx">CURLOPT_RETURNTRANSFER</span><span class="p">,</span> <span class="k">true</span><span class="p">);</span>
    <span class="nb">curl_setopt</span><span class="p">(</span><span class="nv">$ch</span><span class="p">,</span> <span class="nx">CURLOPT_POSTFIELDS</span><span class="p">,</span> <span class="nv">$data</span><span class="p">);</span>
    <span class="nb">curl_setopt</span><span class="p">(</span><span class="nv">$ch</span><span class="p">,</span> <span class="nx">CURLOPT_SSL_VERIFYPEER</span><span class="p">,</span> <span class="k">false</span><span class="p">);</span>
    <span class="nb">curl_setopt</span><span class="p">(</span><span class="nv">$ch</span><span class="p">,</span> <span class="nx">CURLOPT_SSL_VERIFYHOST</span><span class="p">,</span> <span class="k">false</span><span class="p">);</span>

    <span class="nv">$response</span> <span class="o">=</span> <span class="nb">curl_exec</span><span class="p">(</span><span class="nv">$ch</span><span class="p">);</span>
    <span class="nb">curl_close</span><span class="p">(</span><span class="nv">$ch</span><span class="p">);</span>

    <span class="k">return</span> <span class="nv">$response</span><span class="p">;</span>
  <span class="p">}</span>

<span class="cp">?&gt;</span><span class="x"></span>
</pre></div>
</div>
<p>This example can be applied to any other of the existing services.
For understanding purpose, the XML requests are loaded as strings in the example above. To make the code cleaner, you should use the simplexml_load_file() function and load xml external files.</p>
<p>For the record, we provide an specific PHP client which allows you to generate and process any request easily. Please follow this link for futher information: <a class="reference internal" href="../index-table.html#php-api-client-guide"><em>PHP client reference book</em></a>.</p>
</div>


      </div>
      <div class="bottomnav">
      
        <p>
        «&#160;&#160;<a href="howtouse.html">How to use this documentation</a>
        &#160;&#160;::&#160;&#160;
        <a class="uplink" href="../index.html">Contents</a>
        &#160;&#160;::&#160;&#160;
        <a href="api/authentification.html">Authentification</a>&#160;&#160;»
        </p>

      </div>

    <div class="footer">
        &copy; Copyright 2010-2013, FnacMarketplace.
    </div>
  </body>
</html>